//+------------------------------------------------------------------+
//|mtf jurik STLM_hist.mq4 
//| 
//+------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LimeGreen
#property indicator_color2     LimeGreen
#property indicator_color3     Red
#property indicator_color4     Red
#property indicator_color5     Silver
#property indicator_width1     2
#property indicator_width3     2
#property indicator_width5     2
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern int    StlmSmoothLength          = 5;
extern double StlmSmoothPhase           = 0;
extern bool   StlmSmoothDouble          = true;
extern int    StlmPrice                 = PRICE_CLOSE;
extern bool   divergenceVisible         = true;
extern bool   divergenceOnValuesVisible = true;
extern bool   divergenceOnChartVisible  = false;
extern color  divergenceBullishColor    = Navy;
extern color  divergenceBearishColor    = Magenta;
extern string divergenceUniqueID        = "jurik stlm diverge1";
extern bool   HistogramOnSlope          = true;
extern bool   Interpolate               = true;

extern bool   alertsOn                  = true;
extern bool   alertsOnSlope             = true;
extern bool   alertsOnCurrent           = false;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = true;
extern bool   alertsEmail               = false;

extern bool   arrowsVisible             = true;
extern bool   arrowsOnSlope             = true;
extern string arrowsIdentifier          = "jurik stlm arrows1";
extern double arrowsDisplacement        = 1.0;
extern color  arrowsUpColor             = LimeGreen;
extern color  arrowsDnColor             = Red;
extern int    arrowsUpCode              = 241;
extern int    arrowsDnCode              = 242;

//
//
//
//
//

double Upa[];
double Upb[];
double Dna[];
double Dnb[];
double stlm[];
double price[];
double trend[];
double slope[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;
string shortName;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
  {
   IndicatorBuffers(8);
   SetIndexBuffer(0,Upa);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Upb);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Dna);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Dnb);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,stlm);
   SetIndexBuffer(5,price);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,slope);
   
   SetLevelValue(0,0);
   
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue");
      if (calculateValue)
      {
         int s = StringFind(divergenceUniqueID,":",0);
               shortName = divergenceUniqueID;
               divergenceUniqueID = StringSubstr(divergenceUniqueID,0,s);
               return(0);
      }            
      timeFrame = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      shortName = divergenceUniqueID+": "+timeFrameToString(timeFrame)+ "  jurik stlm";
   IndicatorShortName(shortName);
return(0);
}

//
//
//
//
//
   
int deinit()
{
   
   int lookForLength = StringLen(divergenceUniqueID);
   
   for (int i=ObjectsTotal()-1; i>=0; i--) {
   
   string objectName = ObjectName(i);
   if (StringSubstr(objectName,0,lookForLength) == divergenceUniqueID) ObjectDelete(objectName);
   
   }
   
   if (!calculateValue && arrowsVisible) deleteArrows();
   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { Upa[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {   

   for(i=limit; i>=0; i--)
   {
   
      price[i] = iMA(NULL,0,1,0,MODE_SMA,StlmPrice,i);

   double fatl =
      
  0.0982862174 * price[i+0]
+ 0.0975682269 * price[i+1]
+ 0.0961401078 * price[i+2]
+ 0.0940230544 * price[i+3]
+ 0.0912437090 * price[i+4]
+ 0.0878391006 * price[i+5]
+ 0.0838544303 * price[i+6]
+ 0.0793406350 * price[i+7]
+ 0.0743569346 * price[i+8]
+ 0.0689666682 * price[i+9]
+ 0.0632381578 * price[i+10]
+ 0.0572428925 * price[i+11]
+ 0.0510534242 * price[i+12]
+ 0.0447468229 * price[i+13]
+ 0.0383959950 * price[i+14]
+ 0.0320735368 * price[i+15]
+ 0.0258537721 * price[i+16]
+ 0.0198005183 * price[i+17]
+ 0.0139807863 * price[i+18]
+ 0.0084512448 * price[i+19]
+ 0.0032639979 * price[i+20]
- 0.0015350359 * price[i+21]
- 0.0059060082 * price[i+22]
- 0.0098190256 * price[i+23]
- 0.0132507215 * price[i+24]
- 0.0161875265 * price[i+25]
- 0.0186164872 * price[i+26]
- 0.0205446727 * price[i+27]
- 0.0219739146 * price[i+28]
- 0.0229204861 * price[i+29]
- 0.0234080863 * price[i+30]
- 0.0234566315 * price[i+31]
- 0.0231017777 * price[i+32]
- 0.0223796900 * price[i+33]
- 0.0213300463 * price[i+34]
- 0.0199924534 * price[i+35]
- 0.0184126992 * price[i+36]
- 0.0166377699 * price[i+37]
- 0.0147139428 * price[i+38]
- 0.0126796776 * price[i+39]
- 0.0105938331 * price[i+40]
- 0.0084736770 * price[i+41]
- 0.0063841850 * price[i+42]
- 0.0043466731 * price[i+43]
- 0.0023956944 * price[i+44]
- 0.0005535180 * price[i+45]
+ 0.0011421469 * price[i+46]
+ 0.0026845693 * price[i+47]
+ 0.0040471369 * price[i+48]
+ 0.0052380201 * price[i+49]
+ 0.0062194591 * price[i+50]
+ 0.0070340085 * price[i+51]
+ 0.0076266453 * price[i+52]
+ 0.0080376628 * price[i+53]
+ 0.0083037666 * price[i+54]
+ 0.0083694798 * price[i+55]
+ 0.0082901022 * price[i+56]
+ 0.0080741359 * price[i+57]
+ 0.0077543820 * price[i+58]
+ 0.0073260526 * price[i+59]
+ 0.0068163569 * price[i+60]
+ 0.0062325477 * price[i+61]
+ 0.0056078229 * price[i+62]
+ 0.0049516078 * price[i+63]
+ 0.0161380976 * price[i+64];
  
   double satl =
     
- 0.0074151919 * price[i+0]
- 0.0060698985 * price[i+1]
- 0.0044979052 * price[i+2]
- 0.0027054278 * price[i+3]
- 0.0007031702 * price[i+4]
+ 0.0014951741 * price[i+5]
+ 0.0038713513 * price[i+6]
+ 0.0064043271 * price[i+7]
+ 0.0090702334 * price[i+8]
+ 0.0118431116 * price[i+9]
+ 0.0146922652 * price[i+10]
+ 0.0175884606 * price[i+11]
+ 0.0204976517 * price[i+12]
+ 0.0233865835 * price[i+13]
+ 0.0262218588 * price[i+14]
+ 0.0289681736 * price[i+15]
+ 0.0315922931 * price[i+16]
+ 0.0340614696 * price[i+17]
+ 0.0363444061 * price[i+18]
+ 0.0384120882 * price[i+19]
+ 0.0402373884 * price[i+20]
+ 0.0417969735 * price[i+21]
+ 0.0430701377 * price[i+22]
+ 0.0440399188 * price[i+23]
+ 0.0446941124 * price[i+24]
+ 0.0450230100 * price[i+25]
+ 0.0450230100 * price[i+26]
+ 0.0446941124 * price[i+27]
+ 0.0440399188 * price[i+28]
+ 0.0430701377 * price[i+29]
+ 0.0417969735 * price[i+30]
+ 0.0402373884 * price[i+31]
+ 0.0384120882 * price[i+32]
+ 0.0363444061 * price[i+33]
+ 0.0340614696 * price[i+34]
+ 0.0315922931 * price[i+35]
+ 0.0289681736 * price[i+36]
+ 0.0262218588 * price[i+37]
+ 0.0233865835 * price[i+38]
+ 0.0204976517 * price[i+39]
+ 0.0175884606 * price[i+40]
+ 0.0146922652 * price[i+41]
+ 0.0118431116 * price[i+42]
+ 0.0090702334 * price[i+43]
+ 0.0064043271 * price[i+44]
+ 0.0038713513 * price[i+45]
+ 0.0014951741 * price[i+46]
- 0.0007031702 * price[i+47]
- 0.0027054278 * price[i+48]
- 0.0044979052 * price[i+49]
- 0.0060698985 * price[i+50]
- 0.0074151919 * price[i+51]
- 0.0085278517 * price[i+52]
- 0.0094111161 * price[i+53]
- 0.0100658241 * price[i+54]
- 0.0104994302 * price[i+55]
- 0.0107227904 * price[i+56]
- 0.0107450280 * price[i+57]
- 0.0105824763 * price[i+58]
- 0.0102517019 * price[i+59]
- 0.0097708805 * price[i+60]
- 0.0091581551 * price[i+61]
- 0.0084345004 * price[i+62]
- 0.0076214397 * price[i+63]
- 0.0067401718 * price[i+64]
- 0.0058083144 * price[i+65]
- 0.0048528295 * price[i+66]
- 0.0038816271 * price[i+67]
- 0.0029244713 * price[i+68]
- 0.0019911267 * price[i+69]
- 0.0010974211 * price[i+70]
- 0.0002535559 * price[i+71]
+ 0.0005231953 * price[i+72]
+ 0.0012297491 * price[i+73]
+ 0.0018539149 * price[i+74]
+ 0.0023994354 * price[i+75]
+ 0.0028490136 * price[i+76]
+ 0.0032221429 * price[i+77]
+ 0.0034936183 * price[i+78]
+ 0.0036818974 * price[i+79]
+ 0.0038037944 * price[i+80]
+ 0.0038338964 * price[i+81]
+ 0.0037975350 * price[i+82]
+ 0.0036986051 * price[i+83]
+ 0.0035521320 * price[i+84]
+ 0.0033559226 * price[i+85]
+ 0.0031224409 * price[i+86]
+ 0.0031224409 * price[i+87]
+ 0.0025688349 * price[i+88]
+ 0.0022682355 * price[i+89]
+ 0.0073925495 * price[i+90];

      stlm[i]  = iDSmooth(fatl-satl,StlmSmoothLength,StlmSmoothPhase,StlmSmoothDouble,i); 
      Upa[i]   = EMPTY_VALUE;
      Upb[i]   = EMPTY_VALUE;
      Dna[i]   = EMPTY_VALUE;
      Dnb[i]   = EMPTY_VALUE;
      trend[i] = trend[i+1];
      slope[i] = slope[i+1];
      if (stlm[i] > 0)         trend[i] =  1;
      if (stlm[i] < 0)         trend[i] = -1;
      if (stlm[i] > stlm[i+1]) slope[i] =  1;
      if (stlm[i] < stlm[i+1]) slope[i] = -1;
      if (!calculateValue) manageArrow(i); 
               
      if (divergenceVisible)
      {
         CatchBullishDivergence(stlm,i);
         CatchBearishDivergence(stlm,i);
      }
                                     
      if (HistogramOnSlope)
      {
         if (trend[i]== 1 && slope[i] == 1) Upa[i] = stlm[i];
         if (trend[i]== 1 && slope[i] ==-1) Upb[i] = stlm[i];
         if (trend[i]==-1 && slope[i] ==-1) Dna[i] = stlm[i];
         if (trend[i]==-1 && slope[i] == 1) Dnb[i] = stlm[i];
      }
      else
      {                  
         if (trend[i]== 1) Upa[i] = stlm[i];
         if (trend[i]==-1) Dna[i] = stlm[i];
      }
               
  }
  manageAlerts();
  return(0);
  }   
  
  //
  //
  //
  //
  //

  limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
  for(i=limit; i>=0; i--)
  {
     int y = iBarShift(NULL,timeFrame,Time[i]);
        stlm[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StlmSmoothLength,StlmSmoothPhase,StlmSmoothDouble,StlmPrice,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,4,y);
        trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StlmSmoothLength,StlmSmoothPhase,StlmSmoothDouble,StlmPrice,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,6,y);
        slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StlmSmoothLength,StlmSmoothPhase,StlmSmoothDouble,StlmPrice,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,7,y);
        Dna[i]   = EMPTY_VALUE;
        Dnb[i]   = EMPTY_VALUE;
        Upa[i]   = EMPTY_VALUE;
        Upb[i]   = EMPTY_VALUE;
         
        manageArrow(i);

        //
        //
        //
        //
        //
      
        if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

        //
        //
        //
        //
        //

        datetime time = iTime(NULL,timeFrame,y);
           for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
           for(int k = 1; k < n; k++)
              stlm[i+k] = stlm[i] + (stlm[i+n] - stlm[i]) * k/n;
   }
   
   //
   //
   //
   //
   //
   
   for (i=limit;i>=0;i--)
   {
      if (HistogramOnSlope)
          {
             if (trend[i]== 1 && slope[i] == 1) Upa[i] = stlm[i];
             if (trend[i]== 1 && slope[i] ==-1) Upb[i] = stlm[i];
             if (trend[i]==-1 && slope[i] ==-1) Dna[i] = stlm[i];
             if (trend[i]==-1 && slope[i] == 1) Dnb[i] = stlm[i];
          }
          else
          {                  
             if (trend[i]== 1) Upa[i] = stlm[i];
             if (trend[i]==-1) Dna[i] = stlm[i];
          }
                               
   }
   
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      if (alertsOnSlope)
      {
         if (slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] == 1) doAlert(whichBar,"slope changed to up");
            if (slope[whichBar] ==-1) doAlert(whichBar,"slope changed to down");
         }         
      }
      else
      {
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"crossed zero line up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"crossed zero line down");
         }         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," stlm oscillator ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"stlm"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if(arrowsOnSlope)
      {
      
         if (slope[i] != slope[i+1])
         {
            if (slope[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
            if (slope[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
         }         
      }
      else
      {
         if (trend[i] != trend[i+1])
         {
            if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
            if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
         }  
      }         
   }         
}       

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CatchBullishDivergence(double& values[], int i)
{
   i++;
            ObjectDelete(divergenceUniqueID+"l"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"l"+"os" + DoubleToStr(Time[i],0));            
   if (!IsIndicatorLow(values,i)) return;  

   //
   //
   //
   //
   //

   int currentLow = i;
   int lastLow    = GetIndicatorLastLow(values,i+1);
      if (values[currentLow] > values[lastLow] && Low[currentLow] < Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],divergenceBullishColor,STYLE_SOLID);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow],divergenceBullishColor,STYLE_SOLID);
      }
      if (values[currentLow] < values[lastLow] && Low[currentLow] > Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], divergenceBullishColor, STYLE_DOT);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow], divergenceBullishColor, STYLE_DOT);
      }
}

//
//
//
//
//

void CatchBearishDivergence(double& values[], int i)
{
   i++; 
            ObjectDelete(divergenceUniqueID+"h"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"h"+"os" + DoubleToStr(Time[i],0));            
   if (IsIndicatorPeak(values,i) == false) return;

   //
   //
   //
   //
   //
      
   int currentPeak = i;
   int lastPeak = GetIndicatorLastPeak(values,i+1);
      if (values[currentPeak] < values[lastPeak] && High[currentPeak]>High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],divergenceBearishColor,STYLE_SOLID);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak],divergenceBearishColor,STYLE_SOLID);
      }
      if(values[currentPeak] > values[lastPeak] && High[currentPeak] < High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak], divergenceBearishColor, STYLE_DOT);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak], divergenceBearishColor, STYLE_DOT);
      }
}

//
//
//
//
//

bool IsIndicatorPeak(double& values[], int i) { return(values[i] >= values[i+1] && values[i] > values[i+2] && values[i] > values[i-1]); }
bool IsIndicatorLow( double& values[], int i) { return(values[i] <= values[i+1] && values[i] < values[i+2] && values[i] < values[i-1]); }

//
//
//
//
//

int GetIndicatorLastPeak(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] >= values[i+1] && values[i] > values[i+2] && values[i] >= values[i-1] && values[i] > values[i-2]) return(i);
   return(-1);
}

//
//
//
//
//

int GetIndicatorLastLow(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] <= values[i+1] && values[i] < values[i+2] && values[i] <= values[i-1] && values[i] < values[i-2]) return(i);
   return(-1);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   string   label = divergenceUniqueID+first+"os"+DoubleToStr(t1,0);
   if (Interpolate) t2 += Period()*60-1;
    
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   if (Interpolate) t2 += Period()*60-1;
   
   string label = divergenceUniqueID+first+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str) {
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--) {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}      
      
      
   
      


